#ifndef JUEGO_H_
#define JUEGO_H_

// Incluimos la cabecera principal de StdPijo
#include "StdPijo.h"

#include <iostream>

// Incluimos cabeceras para números aleatorios y retardos
#include <ctime>
#include <cstdlib>
#include <unistd.h>
#include "string.h"

using namespace std;

class Juego{
private:
	int nivelActual; //Variable que guarda el nivel en el que se encuentra la partida
	int puntuacionPartida; //Variable que guarda la puntuación en ese momento
	int incrementoTiempo; //Variable que guarda el número de bonus que incrementa en cada nivel
	int tiempoInicial; //Variable que guarda el bonus inicial de la partida
	int puntosPorAvance; //Variable que guarda los puntos por cada avance
	int bonusActual; //Bonus que hay en ese momento en la partida
	int posicionPersonaje[2]; //Posición en coordenadas del personaje a controlar
	int posicionEnemigos[8][2]; //Posición de los enemigos
	char tablero[2][80][24]; //Array de tableros posibles para jugar
	int tableroActual; //Entero que determina el tablero sobre el que se va a jugar la partida
	bool supercoco; //Activa o desactiva el supercoco
	int movimientosSupercoco; //Guarda la cantidad de turnos que se mantiene el supercoco activo
	int numeroCocos; //Guarda el nújmero de cocos que hay en la pantalla
	bool moverTodo; //Activa o desactiva el movimiento del juego
	int direccionEnemigos[8][2]; //Determina la dirección a la que se dirigen los enemigos
	int muerteEnemigos[8][2]; //Determina cuáles són los enemigos en pantalla o no
	int tiempoSupercoco; //Tiempo que tardan los fantasmas en reaccionar cuando el supercoco está activo
	int vidas; //Número de vidas del personaje
	bool borrarBonus; //Borra el bonus al perder una vida
	int radioPersecucion; //Área en la que si el personaje se adentra, el fantasma va hacia él

public:
	Juego(){
		nivelActual=1;
		puntuacionPartida=0;
		incrementoTiempo=500;
		tiempoInicial=3000;
		puntosPorAvance=50;
		bonusActual=tiempoInicial;
		supercoco=false;
		movimientosSupercoco=0;
		numeroCocos=471;
		moverTodo=false;
		for(int i = 0; i<8; i++){
			posicionEnemigos[i][0]=0;
			posicionEnemigos[i][1]=0;
			direccionEnemigos[i][1]= rand() % 21 + 2;

			if(rand() % 2 == 0)
				do{

				direccionEnemigos[i][0]= rand() % 5 + 3;
				}while(direccionEnemigos[i][0] % 2 == 0);
			else
				do{
				direccionEnemigos[i][0]= rand() % 5 + 71;
				}while(direccionEnemigos[i][0] % 2 == 0);

			muerteEnemigos[i][0]=1;
			muerteEnemigos[i][1]=0;
		}
		tiempoSupercoco=0;
		vidas=3;
		borrarBonus=0;
		radioPersecucion=5;
	}

	void iniciarJuego(int modo); //Se inicia el juego
	void mostrarCuentaAtras(); //Muestra la cuentra atrás antes de empezar a jugar
	void mostrarDatosJuego(); //Muestra las minas y el nivel de la partida
	void restarBonus(); //Resta el bonus
	void mostrarBonus(); //Muestra el bonus por pantalla
	void mostrarPuntuacion(); //Muestra la puntuación por pantalla
	void crearTableros(); //Módulo que crea la pantalla donde se va a jugar la partida
	void mostrarTablero(); //Muestra el campo de minas
	bool controlPersonaje(); //Controla los diferentes sucesos del personaje con las minas y los objetos
	void controlEnemigos(int h,bool &muerte);
	void generarEnemigos(); //Crea enemigos y los coloca en el sitio inicial
	int pantallaFinNivel(); //Pantalla para seleccionar si seguir jugando o finalizar
	int getPuntuacion(){return puntuacionPartida;}
	int getNivel(){return nivelActual;}
};


#endif /* JUEGO_H_ */
